(* Copyright 2018 Jonas Schöpf
 * GNU Lesser General Public License
 *
 * This file is part of TTT2.
 *
 * TTT2 is free software: you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or (at your
 * option) any later version.
 *
 * TTT2 is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
 * License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with TTT2. If not, see <http://www.gnu.org/licenses/>.
 *)

(*** OPENS ********************************************************************)
open Util;;

(*** MODULES ******************************************************************)
module Parse = Parsec.MakeCharParser(Parsec.StringInput);;

(*** GLOBALS ******************************************************************)
let (>>=) = Parse.(>>=);;
let (<|>) = Parse.(<|>);;

(*** FUNCTIONS ****************************************************************)
(* parser functions *)

let parse_extsmt : (string * string list) Parse.t =
  (* let word = Parse.many1 @@ (Parse.letter <|> Parse.oneof "-:" <|> Parse.digit) in *)
  let white_space = Parse.many1 @@ Parse.char ' ' in
  Parse.sep_by1 white_space (Parse.many1 @@ Parse.any) >>= fun words ->
  List.map String.of_char_list words
  |> function
    | tool::flags -> Parse.return (tool, flags)
;;
